// Untahris (Common Playground)
// copyright (C) 2006 longuens@users.sourceforge.net
// Released under GNU General Public License (see the file COPYING)
// --------------------------------------------------------------
// Pad & Ball.

struct OPad : TPlayObject {
  public:
  int x;
  int y;
  int y0;
  int y1;
  int ptype;
  OPad(int _owner, int _x, int _y) : 
    x(_x), y(_y) {
    owner = _owner;
    if(x < 512 * g.sizeX) ptype = 0;
    else ptype = 1;
    time = g.time;
    g.objects.push_back(this);
    }
  OPad(TBuffer &b) {
    b.get(owner); 
    b.get(x); b.get(y); b.get(time);
    }
  void save(TBuffer &b) {
    b.putChar(8);
    b.put(owner); 
    b.put(x); b.put(y); b.put(time);
    }
  void go() {
    if(ow()->key[keyUp] && g.map[DeCtr(y-2560-192)][DeCtr(x)] == cFree) {
      y -= 192;
      }
    if(ow()->key[keyDown] && g.map[DeCtr(y+2560+192)][DeCtr(x)] == cFree) {
      y += 192;
      }
    if(ow()->key[keyLeft]) {
      bool ok = true;
      for(int y0=DeCtr(y-2560); y0 <= DeCtr(y+2560); y0++) {
        if(g.map[y0][DeCtr(x-256-96)] != cFree) ok = false;
        if(g.map[y0][DeCtr(x-256-96-1024)] != cFree) ok = false;
        }
      if(ok) x -= 96;
      }
    if(ow()->key[keyRight]) {
      bool ok = true;
      for(int y0=DeCtr(y-2560); y0 <= DeCtr(y+2560); y0++) {
        if(g.map[y0][DeCtr(x+256+96)] != cFree) ok = false;
        if(g.map[y0][DeCtr(x+256+96+1024)] != cFree) ok = false;
        }
      if(ok) x += 96;
      }
    
    y0 = DeCtr(y);
    y1 = DeCtr(y);
    while(g.map[y0-1][DeCtr(x)] == cFree) y0--;
    while(g.map[y1+1][DeCtr(x)] == cFree) y1++;
    
    for(int o=0; o<size(g.objects); o++) if(g.objects[o])
      if(g.objects[o]->reactToPad(this)) return;
    time += spd()/4;
    return;
    }
  void draw() {
    int x0 = CTG(x - 256);
    int x1 = CTG(x + 256);
    int y0 = CTG(y - 2560);
    int y1 = CTG(y + 2560);
    for(int xx=x0; xx<x1; xx++)
    for(int yy=y0; yy<y1; yy++) d.putpix(xx, yy, ow()->color);
    }
  void reactToKey(PlayerKey pk, bool pressed);
  };

struct OBall : TPlayObject {
  public:
  int x;
  int y;
  int dir;
  int speed;
  OBall(int _owner, int _x, int _y, int _dir) : 
    x(_x), y(_y), dir(_dir) {
    owner = _owner;
    time = g.time;
    speed = 7;
    g.objects.push_back(this);
    }
  OBall(TBuffer &b) {
    b.get(owner); 
    b.get(x); b.get(y); b.get(dir); b.get(time);
    b.get(speed);
    }
  void save(TBuffer &b) {
    b.putChar(9);
    b.put(owner); 
    b.put(x); b.put(y); b.put(dir); b.put(time);
    b.put(speed);
    }
  int reflect(int di) {
    int newdir = dir;
    int d = dir-di;
    if(d<0) d = -d;
    d%=360;
    if(d>180) d=360-d;
    if(d < 90) { // towards...
      newdir = di+di+180-dir;
      newdir %= 360;
      newdir += 360;
      newdir %= 360;
      }
    return newdir;
    }
  void mayChangeDir(int ux, int uy, int di) {
    int nx = DeCtr(ux);
    int ny = DeCtr(uy);
    if(destroyAt(nx, ny, owner)) {
      CellType m = bigType(nx, ny);
      if(isBonus(m)) {
        if(m == cBonusAmmo) {
          ow()->ammo += 10;
          ow()->score += scoreGain();
          }
        if(m == cBonusLevel) {
          ow()->level += 10;
          ow()->score += 10*scoreGain();
          }
        if(m == cBonusScore) {
          ow()->score += 5*scoreGain();
          }
        placeBigRandomly(m, 0);
        clearBig(nx, ny, cFree, 0);
        }
      dir = reflect(di);
      }
    }
  void go() {
    x += degx[dir];
    y += degy[dir];
    int sdir = dir;
    for(int m=0; m<90; m++) for(int u=0; u<360; u+=90) if(dir == sdir) {
      int di = m+u;
      mayChangeDir(x+4*degx[di], y+4*degy[di], di);
      }
    time += speed;
    return;
    }
  void draw() {
    d.setIconColor(ow()->color);
    d.ball.drawAtCentered(CTG(x), CTG(y));
    }
  bool reactToPad(OPad *pad) {
    int yd = pad->y - y;
    if(x >= pad->x-768 && x <= pad->x+768 && yd >= -2560 && yd <= 2560) {
      owner = pad->owner;
      int di = 90 + (45 * yd) / 2560;
      if(pad->ptype == 0) di = -di; 
      speed = spd()/6+1;
      dir = reflect(di);
      }
    if(y >= Ctr(pad->y0) && y <= Ctr(pad->y1) && (pad->ptype ? x>pad->x : x<pad->x)) {
      int p = pad->owner;
      pad->killedBy(owner);
      if(owner == p) owner = 0;
      return true;
      }
    return false;
    }

  bool reactToThruster(OThruster *enemy) {
    if(calcDistance(x-enemy->x, y-enemy->y) < 8*128 + 4*128) {
      enemy->killedBy(owner);
      dir = g.rand() % 360;
      return true;
      }
    return false;
    }
  bool reactToBullet(OBullet *bullet) {
    if(calcDistance(x-bullet->x, y-bullet->y) < 8*128 + 4*128) {
      dir = g.rand() % 360;
      return true;
      }
    return false;
    }
  };

void OPad::reactToKey(PlayerKey pk, bool pressed) {
  if(!pressed) return;
  int bdir = 1-ptype-ptype;
  switch(pk) {
    case keyFire: case keyWater:
      if(ow()->useAmmo(2)) {
        new OBullet(owner, x+2048*bdir, y-2048, bdir*bulletSpeed(), 0);
        new OBullet(owner, x+2048*bdir, y+2048, bdir*bulletSpeed(), 0);
        }
      break;
    case keyAir: case keyEarth:
      new OBall(owner, x+2048*bdir, y, (ptype ? 270 : 90) + g.rand() % 45 - g.rand() % 45);
      break;
    }
  }
