// Untahris (Common Playground)
// copyright (C) 2006 longuens@users.sourceforge.net
// Released under GNU General Public License (see the file COPYING)
// --------------------------------------------------------------
// Snake (tail & head), or UTron.

struct OSnakeTail : TPlayObject {
  public:
  int x;
  int y;
  OSnakeTail(int _x, int _y) : x(_x), y(_y) {
    owner = g.owner[y][x];
    time = g.time + 300;
    g.objects.push_back(this);
    }
  OSnakeTail(TBuffer &b) {
    b.get(owner); b.get(x); b.get(y); b.get(time);
    }
  void save(TBuffer &b) {
    b.putChar(5);
    b.put(owner); b.put(x); b.put(y); b.put(time);
    }
  void go() {
    if(ow()->typeval > 1) {
      ow()->typeval--;
      time += spd();
      return;
      }
    CellType ct = g.map[y][x];
    int d = isSnakeDir(g.map[y][x]);
    if(d != 4) {
      g.mapSet(x,y, cFree, 0);
      x += kx[d];
      y += ky[d];
      time += spd();
      }
    else if(g.map[y][x] == cSnakeDead) {
      g.mapSet(x,y, cFree, 0);
      g.deleteObject(this);
      }
    else g.deleteObject(this);
    }
  };

struct OSnakeHead : TPlayObject {
  public:
  int x;
  int y;
  int dir;
  bool hasTail;

  OSnakeHead(int _owner, int _x, int _y, int _dir, bool _hasTail) : x(_x), y(_y), dir(_dir) {
    owner = _owner;
    g.mapSet(x,y, cSnakeHead, owner);
    time = g.time;
    g.objects.push_back(this);
    if((hasTail = _hasTail))
      new OSnakeTail(x, y);
    }
  OSnakeHead(TBuffer &b) {
    b.get(owner);
    b.get(x); b.get(y); b.get(time); b.get(dir); b.get(hasTail);
    }
  void save(TBuffer &b) {
    b.putChar(2);
    b.put(owner); b.put(x); b.put(y); b.put(time); b.put(dir); b.put(hasTail);
    }
  void go() {
    if(g.map[y][x] != cSnakeHead) {
      // it seems something killed us...
      int o = g.owner[y][x];
      g.mapSet(x,y, hasTail ? cSnakeDead : cSnakeTRON, owner);
      killedBy(o);
      return;
      }
    int sx=x, sy = y;
    x += kx[dir];
    y += ky[dir];
    CellType m;
    if((m = bigType(x, y)) != cFree) {
      if(m == cBonusScore) {
        ow()->score += scoreGain() * 2;
        ow()->typeval += 4;
        }
      if(m == cBonusLevel) {
        ow()->score += scoreGain() * 10;
        int ospd = spd();
        ow()->level += 10;
        }
      if(m == cBonusAmmo) {
        ow()->score += scoreGain();
        ow()->ammo += 10;
        }
      placeBigRandomly(m, 0);
      clearBig(x, y, cFree, 0);
      }
    if(g.map[y][x] == cFree) {
      g.mapSet(sx, sy, hasTail ? snakeDirFor(dir) : cSnakeTRON, owner);
      g.mapSet(x,y, cSnakeHead, owner);
      time += spd();
      }
    else {
      int oo = g.owner[y][x];
      if(g.map[y][x] == cBomb1 || g.map[y][x] == cBomb2)
        g.mapSet(x,y,cExplosion, owner);
      g.mapSet(sx,sy, hasTail ? cSnakeDead : cSnakeTRON, owner);
      killedBy(oo);
      return;
      }
    }
  void reactToKey(PlayerKey pk, bool pressed) {
    if(!pressed) return;
    if(int(pk)<4 && int(pk) != (dir^2)) dir = int(pk);
    if((pk == keyFire || pk == keyEarth || pk == keyAir || pk == keyWater) && ow()->useAmmo(5)) {
      new OBullet(owner, Ctr(x) + kx[dir] * 2048, Ctr(y) + ky[dir] * 2048, kx[dir] * bulletSpeed(), ky[dir] * bulletSpeed());
      }
    }
  };
