// Untahris (Common Playground)
// copyright (C) 2006 longuens@users.sourceforge.net
// Released under GNU General Public License (see the file COPYING)
// --------------------------------------------------------------
// Thruster.

struct OThruster : TPlayObject {
  public:
  int x;
  int y;
  int dx;
  int dy;
  int dir;
  OThruster(int _owner, int _x, int _y) : 
    x(Ctr(_x)), y(Ctr(_y)) {
    owner = _owner;
    time = g.time;
    dx = 0; dy = 0; dir = 0;
    g.objects.push_back(this);
    }
  
  OThruster(TBuffer &b) {
    b.get(owner); 
    b.get(x); b.get(y);
    b.get(dx); b.get(dy);
    b.get(time); b.get(dir);
    }
  void save(TBuffer &b) {
    b.putChar(3);
    b.put(owner); 
    b.put(x); b.put(y);
    b.put(dx); b.put(dy);
    b.put(time); b.put(dir);
    }

  int oo;
  
  bool testCrash(int x, int y) {
    int nx = DeCtr(x);
    int ny = DeCtr(y);
    if(nx<0) nx = 0;
    if(ny<0) ny = 0;
    if(nx>g.sizeX-1) nx = g.sizeX-1;
    if(ny>g.sizeY-1) ny = g.sizeY-1;
    CellType m = bigType(nx, ny);
    oo = g.owner[ny][nx];
    if(m != cFree) {
      switch(m) {
        case cBonusLevel:
          ow()->level += 10;
          ow()->score += scoreGain() * 10;
          break;
        case cBonusScore: 
          ow()->typeval += 1000;
          ow()->score += scoreGain();
          break;
        case cBonusAmmo:
          ow()->ammo += 10;
          ow()->score += scoreGain();
          break;
        }
      placeBigRandomly(m, 0);
      clearBig(nx, ny, cFree, 0);
      }
    return destroyAt(nx, ny, owner, dfDestroyCannons);
    }
    
  void go() {
    x += dx;
    y += dy;
    dy += 6;
    if(g.pl[owner]->key[keyRight]) dir += 15;
    if(g.pl[owner]->key[keyLeft]) dir += 345;
    dir %= 360;
    if(g.pl[owner]->key[keyUp]) {
      dx += degx[dir]/2;
      dy += degy[dir]/2;
      ow()->typeval -= 20;
      }
    bool b = false;
    int oo2 = ow()->index;
    if(testCrash(x, y)) b = true, oo2 = oo;
    if(testCrash(x+8*degx[(dir+120)%360], y+8*degy[(dir+120)%360])) b = true, oo2 = oo;
    if(testCrash(x+8*degx[(dir+240)%360], y+8*degy[(dir+240)%360])) b = true, oo2 = oo;
    if(testCrash(x+8*degx[dir], y+8*degy[dir])) b = true, oo2 = oo;
    for(int o=0; o<size(g.objects); o++) if(g.objects[o])
      if(g.objects[o]->reactToThruster(this)) return;
    if(b || ow()->typeval < 0) {
      killedBy(oo2);
      return;
      }
    else time += spd();
    }
  void draw() {
    d.setIconColor(ow()->color);
    d.thruster.drawAtRotated(CTG(x), CTG(y), degx[dir], degy[dir]);
    }
  void reactToKey(PlayerKey pk, bool pressed) {
    if(!pressed) return;
    if(pk == keyFire && ow()->useAmmo(2)) {
      new OBullet(owner, x + degx[dir] * 8, y + degy[dir] * 8, 
        dx/spd() + (degx[dir] * bulletSpeed()) / 128, dy/spd() + (degy[dir] * bulletSpeed()) / 128);
      }
    if(pk == keyEarth && ow()->useAmmo(2)) {
      new OBullet(owner, x - degx[dir] * 8, y - degy[dir] * 8, 
        dx/spd() - (degx[dir] * bulletSpeed()) / 128, dy/spd() - (degy[dir] * bulletSpeed()) / 128);
      }
    if(pk == keyAir && ow()->useAmmo(4)) {
      new OBullet(owner, x + degy[dir] * 8, y - degx[dir] * 8, 
        dx/spd() + (degy[dir] * bulletSpeed()) / 128, dy/spd() - (degx[dir] * bulletSpeed()) / 128);
      new OBullet(owner, x - degy[dir] * 8, y + degx[dir] * 8, 
        dx/spd() - (degy[dir] * bulletSpeed()) / 128, dy/spd() + (degx[dir] * bulletSpeed()) / 128);
      }
    }
  bool reactToThruster(OThruster *enemy) {
    if(this == enemy) return false;
    if(calcDistance(x-enemy->x, y-enemy->y) < 8*128*2) {
      int o0 = owner;
      int oe = enemy->owner;
      enemy->killedBy(o0);
      killedBy(oe);
      return true;
      }
    return false;
    }
  bool reactToBullet(OBullet *bullet) {
    if(calcDistance(x-bullet->x, y-bullet->y) < 8*128) {
      killedBy(bullet->owner);
      return true;
      }
    return false;
    }
  };

